{{PrAlMirr:  CMap: PrALMirr
2014/11/18  0.1 Implementation of data mirroring between processes
}}

'fixit: check for valid index before storing values

CON 'Process Control of Mirror Process
  #1, Idle, Run   ' 
  MirrVers = -3    ' Process version at return has to be negative as the number of parameters passed at call is positive!
{  NmbMirrPar = 29 ' Number of pointers related Mirror object     in PrCB Process Control Block
Dat PrCBMirr long  @MirrCmd,      @txBuHead,     @txBuTail,     @txBuEnd_,     @txBuffer,      @rxBuHead,     @rxBuTail,     @rxBuEnd_
             long  @rxBuffer,     @LclNodId,     @NmbMirrE,     @ButtClck+(4*0), @ButtClck+(4*1),  @ButtClck+(4*2), @ButtClck+(4*3), @ButtClck+(4*4)
             long  @ButtClck+(4*5), @ButtClck+(4*6), @ButtClck+(4*7), @HiSpeed,      @LoSpeed,       @Stirrer,      @ES_Oben,      @ES_Syri
             long  @ES_Unten,     @ButtClck+(4*1),   @SPSState,  @Testing,  @Testing1
}
EmptyToken = 0

VAR  ' block containing variables
  byte  ID_cog     ' cog ID) Id des lokalen Cogs
  long  Sk[60]     ' cog's stack) Stack des Cogs

PUB Start( GlobPtr, AddrOffs ) | i    ' Start a cog: spin or asm

  Stop  ' stop cog using private method Stop) Start can restart, therefore stop a possibly running cog first
  ' Create a local copy of the global pointer array and do the address correction "quick and dirty"
  repeat i from 0 to LONG[LONG[GlobPtr +   0]+AddrOffs]-1       
    LONG[@LoclPtr + (i<<2)] := LONG[GlobPtr + (i<<2)] + AddrOffs
      
  ifnot ID_cog  ' if cog ID isn't valid i.e. ID_cog=0)
    ID_cog := cognew(CogProc, @Sk) + 1       '  create cog/process that runs CogProc method using Sk stack )
  ' now wait for started process to return version #
  Repeat while ( i := LONG[LONG[GlobPtr +  0] + AddrOffs]) > 0
  LONG[LONG[GlobPtr +  0] + AddrOffs] := 0                      ' clear command from version#
  Result := i<<4 + ID_Cog  '  Return 16* Version + ID-Cog

PRI Stop           '  
  if ID_cog  '  if ID_cog is valid i.e. ID_Cog<>0; if cog exists ID_cog is in {1,2,3,...,8} )
    cogstop(ID_cog~ - 1)       '  stop cog/process with "ID_cog-1" ID; cogs have IDs in range (0,1,2,...,7);

PRI CogProc | i, onems , TimeOut, ComIn , j, token, State, iTok
{ Commands:
  1: Idle
  2: Run the pulse generator
}  
  LclNodId := long[LclNodIdPtr]           ' get Id of this process
  NmbMirrE := long[NmbMirrEPtr]           ' Number of elements to mirror                                   
  repeat i from 0 to NmbMirrE-1          
    MirrValu[i] := long[MirrAdrsPtr[i]]     ' Set Mirror Value to actual value
    MirrTarg[i] := long[NmbMirrEPtr+4+4*i]  ' Address of target: Node + idx

' FIXIT: in this place check if token ring is operational

  Long[CommandPtr] := MirrVers  ' Acknowledge command to show process is running

  repeat
  
    repeat while (LocCmd := Long[CommandPtr]) == 0 ' Wait for command (idling) (<0:version returned)

    case LocCmd  ' switch-case statement; execute appropriate action based on local command)
   
      Idle:     ' Idle (has to be recognized in Idle state too)
        Long[CommandPtr] := 0        ' acknowledge command 
   
      Run:
        Long[CommandPtr] := 0        ' acknowledge command

        iTok    := 1                 'Scanning the Mirrors
        TimeOut :=  cnt + ClkFreq/5
        token   := 0                 ' Der token ist zuerst einmal leer
        State   := 0                 ' State-Machine
        repeat while (LocCmd := Long[CommandPtr]) == 0      ' run until interupted

          case state

            0:    ' Wait for token to arrive with time-out

              if (Token :=  com_rxcheck) => 0      ' token arrived
                Token &= $FF                       ' mask byte
                State := 1                       ' In Zustand 1 umschaltent
           
              elseif LclNodId == 1                 ' falls Node = 1
                if (TimeOut - cnt ) < 0        ' es gab ein Timeout
                  TimeOut += ClkFreq/5
                  com_out ( 0 )                    'seed-Token losschicken 
       
            1:    ' Token bei 1, prfen ob leer oder nicht
              
              if token & 3   ' Node-Adresse testen
                State := 2   ' Token war nicht leer
              else
                State := 3   ' Token war leer
           
            2:     ' nicht leerer Token bei 1

              if (token & 3) <> LclNodId      ' Token nicht fr diesen Knoten?
                 com_out(token)              ' Token mit Information weitergeben
                 com_out(com_getKey)         ' und noch ein Long hinterher
                 com_out(com_getKey)
                 com_out(com_getKey)
                 com_out(com_getKey)
                 State := 0                   ' Neuen Token erwarten                                              
               
              else                            ' Token ist fr diesen Knoten

                token ~>= 2                   ' Wertezeiger richten
                byte[@MirrValu[token]][0] := com_getKey    ' 4 ankommende Bytes in den Spiegel schreiben 
                byte[@MirrValu[token]][1] := com_getKey  
                byte[@MirrValu[token]][2] := com_getKey  
                byte[@MirrValu[token]][3] := com_getKey  

                long[MirrAdrsPtr[token]]  := MirrValu[token]  ' und den Spiegelwert in den eigentlichen Wert kopiern 
                
                State := 3   ' Nun sehen, ob was zu senden ist.                                              

            3:      ' Testen ob Sendebedarf (anderswo festgestellt)
            
              iTok++
              if iTok => NmbMirrE
                iTok:= 0
              if (MirrValu[iTok] <> long[MirrAdrsPtr[iTok]]) AND (MirrTarg[iTok] & 3)  ' Wenn Daten verndert  UND ZielKnoten nicht 0

                MirrValu[iTok] := long[MirrAdrsPtr[iTok]]   ' Daten in Spiegel kopieren

                com_out ( MirrTarg[iTok] )               'Target
    
                com_out (byte[@MirrValu[iTok]][0])                 ' Wert
                com_out (byte[@MirrValu[iTok]][1])                 ' Wert
                com_out (byte[@MirrValu[iTok]][2])                 ' Wert
                com_out (byte[@MirrValu[iTok]][3])                 ' Wert
                 
              else   ' keine Daten verndert
                com_out(0)        ' leeren Token weitergeben
            
              State := 0
              

PUB  com_out(txbyte)  ' Umstellen auf pointer in Hub

'' Send byte (may wait for room in buffer)

  repeat while  ((LONG[txBuHeadPtr] - LONG[txBuTailPtr] +1)==0) or ( ( LONG[txBuHeadPtr] == txBuEnd_Ptr) and (LONG[txBuTailPtr] == txBufferPtr)) ' wait until send buffer not completly filled (tail == head+1)
  byte[LONG[txBuHeadPtr]] := txbyte           ' store to free place
  LONG[txBuHeadPtr] ++
  if LONG[txBuHeadPtr] > txBuEnd_Ptr
      LONG[txBuHeadPtr] := txBufferPtr

  if SeCoMode & %1000
    com_getKey


PUB com_getKey : rxbyte

'' Receive byte (may wait for byte)
'' returns $00..$FF (-1 if no input present)

  repeat while (rxbyte := com_rxcheck) < 0

PUB com_rxcheck : rxbyte

'' Check if byte received (never waits)
'' returns -1 if no byte received, $00..$FF if byte
  rxbyte--
  if LONG[rxBuTailPtr] <> LONG[rxBuHeadPtr]                          
    rxbyte  := byte[LONG[rxBuTailPtr]]                     
    LONG[rxBuTailPtr] ++
    if LONG[rxBuTailPtr] > rxBuEnd_Ptr
      LONG[rxBuTailPtr] := rxBufferPtr


DAT  '  block containing data )
  LoclPtr
  CommandPtr   long  0   ' pointer to command of this process

  txBuHeadPtr  long  0   ' pointer auf den Zeiger des Sendepufferkopfes
  txBuTailPtr  long  0   ' pointer auf den Zeiger des Sendepufferschwanzes
  txBuEnd_Ptr  long  0   ' Adresse des Bufferendes
  txBufferPtr  long  0   ' Adresse Sendepuffer anfang
  rxBuHeadPtr  long  0   ' pointer auf den Zeiger des Empfngerpufferkopfes
  rxBuTailPtr  long  0   ' pointer auf den Zeiger des Empfngerpufferschwanzes
  rxBuEnd_Ptr  long  0   ' Adresse des Bufferendes
  
  rxBufferPtr  long  0   ' Adresse Empfangspuffer anfang
  LclNodIdPtr  long  0   ' Id dieses Prozesses
  NmbMirrEPtr  long  0   ' Anzahl zu spiegelnder Elemente
  MirrAdrsPtr  long  0   ' Pointer auf zu spiegelnde Elemente
               long  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ' 32 Werte fr den Spiegel
               long  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 '  
                    
'--------------------
  LocCmd       long  0
                    
  SeCoMode     long  0      ' Modus serielle Kommunikation: hier: echo-Zeichen abfangen
  LclNodId     long  0      ' Id dieses Prozesses
  NmbMirrE     long  0      ' Anzahl der Spiegelelemente
  MirrValu     long  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ' 32 Werte fr den Spiegel
               long  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 '  
  MirrTarg     long  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ' 32 Werte fr die Adressen
               long  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ' 
FIT 