{{
2014/11/22 na: Inter-Propeller Communication: first version. Master: LclID: 1, Slave: LoclID > 1 (2)
2014/11/17 na: start of development
Demonstration of New Buttons object on a Quickstart board
}}

OBJ
  Butt          : "QSButtons.spin"
  ToBu          : "ToucButt.spin"
  Mirr          : "PrALMirr.spin"    ' to mirror data via token ring
  SeCo          : "LIN_FullDuplexSerial_V1" ' Full duplex serial with LIN-Header feature

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  onems = 80_000
  {{ Incremental encoder}   ' if both pins 0 : no incremental encoder
  PinA = 6
  PinB = 7

 ' {{ Buttons }}
  MaxButt   =  8    ' Number of buttons to check
  Butt00Pin =  0    ' pin number
  Butt01Pin =  1    ' pin number
  Butt02Pin =  2    ' pin number
  Butt03Pin =  3    ' pin number
  Butt04Pin =  4    ' pin number
  Butt05Pin =  5    ' pin number

  LEDBase   = 16


  #1, St_Idle, St_UP_, St_Relax, St_Dwn, Trans1U, Trans2U, Trans3U, Trans1D, Trans2D, Trans3D, Trans4

  txpin     =    26                                        
  rxpin     =    27 
  LocalNode =    1 ' ID of this node: 1: Master, >1: Slave
  TN        =    2 ' target node
  defbdrat  = 20000  '115200 ' 10080 ' 9600  '
  defMode   =     0  '2'3 ' inverted pins : tx inverted
  
CON ' Commands for SeCo
  #1, Idle, Run, ParReLoa, LIN_Msg
  SecoVers = -4   ' Process version at return has to be =< 0 as the number of parameters passed at call is positive!
  NmbSeCoPar = 16 ' Number of pointers related to serial communication object     in PrCB Process Control Block 
Dat PrCBSeCo long  @SeCoCmd,  @rxPinNmb, @txPinNmb, @rxBiTics, @txBiTics, @SeCoMode, @rxFreeee, @txFreeee
             long  @rxBuHead, @rxBuTail, @rxBuffer, @rxBuEnd_, @txBuHead, @txBuTail, @txBuffer, @txBuEnd_

SeCoCog  long 0         ' Cog running SerialCommunicationProcess
SeCoCmd  long 0         ' Command for serial communication
rxPinNmb long rxpin     ' pin number of input
txPinNmb long txpin     ' pin number of output
rxBiTics long 0         ' Number of counter tics per bit: 1/Baudrate
txBiTics long 0         ' Number of counter tics per bit: 1/Baudrate
SeCoMode long defMode   ' mode of serial connection
rxFreeee long 0         ' not used yet
txFreeee long 0         ' not used yet 
rxBuHead long 0         ' input buffer head: next input to get
rxBuTail long 0         ' input buffer tail: fetch received bytes from here
rxBuffer byte 0,0,0,0,0,0,0,0 ' Start address of input buffer
         byte 0,0,0,0,0,0,0
rxBuEnd_ byte 0         ' end address of input buffer
txBuHead long 0         ' output buffer head: next byte to be send         
txBuTail long 0         ' output buffer tail: place byte to send here
txBuffer byte 0,0,0,0,0,0,0,0 ' Start address of output buffer             
         byte 0,0,0,0,0,0,0
txBuEnd_ byte 0         ' end of output buffer                             

CON 'Commands for Touch Buttons Detector
'  #1, Idle, Run   ' Load Parameters, .... to be updated, now just simple
  ToBuVers = -3  ' Process version at return has to be negative as the number of parameters passed at call is positive!
  NmbToBuPar = 03 ' Touch Button Detector process: number of parameters
DAT  PrCBToBu long @ToBuCmd, @ToBuRegi, @DecayTim                                                 
ToBuCmd     long  0 ' to control the Touch Button Detector process
ToBuRegi    long  0 ' This register reflects the pins decayed state, at start: Pins to detect
DecayTim    long  0 ' Time to allow signal decay

CON 'Commands for Button and Encoder input
'  #1, Idle, Run   ' Load Parameters, .... to be updated, now just simple
  ButtVers = -4  ' Process version at return has to be negative as the number of parameters passed at call is positive!
  ButtPola = 1    ' 0: low active button, 1: high active button
  ButtMode = 1    ' 0: read pin directly, 1: Read Pins from Register, 2: Matrix?

  NmbButtPar = 07 ' Button process: number of parameters
DAT  PrCBButt long @ButtCmd, @ButtCoun, @ButtPins, @ButtStat, @ButtClck, @ButtDClk, @ToBuRegi                                                      
ButtCmd     long  0 ' to control the Button process
ButtCoun    long  MaxButt ' Counter of the quadrature input, at start: the number of buttons to check
ButtPins    long  Butt00Pin, Butt01Pin, Butt02Pin, Butt03Pin, Butt04Pin, Butt05Pin ', Butt06Pin, Butt07Pin, Butt08Pin, Butt09Pin, Butt10Pin
ButtStat    long  PinA<<5+PinB, ButtPola, ButtMode, 0, 0, 0, 0, 0, 0, 0, 0   ' Status of the button  (Init Incremental encoder pins)
ButtClck    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   ' Button is clicked
ButtDClk    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   ' Button is double clicked


CON 'Process Control of Mirror Process   : very likely, the process control block is diffent for every application
'  #1, Idle, Run   ' 
  MirrVers = -3    ' Process version at return has to be negative as the number of parameters passed at call is positive!
  NmbMirrPar = 27 ' Number of pointers related Mirror object     in PrCB Process Control Block
Dat PrCBMirr long  @MirrCmd,        @txBuHead,       @txBuTail,     @txBuEnd_,       @txBuffer,        @rxBuHead,       @rxBuTail,       @rxBuEnd_
             long  @rxBuffer,       @LclNodId,       @NmbMirrE,     @ButtStat+(4*0), @ButtDclk+(4*1),  @ButtDClk+(4*2), @ButtStat+(4*3), @ButtStat+(4*4)
             long  @ButtDClk+(4*5), @ButtClck+(4*6), @ButtClck+(4*7), @ButtMirr+(4*0), @ButtMirr+(4*1),  @ButtMirr+(4*2), @ButtMirr+(4*3), @ButtMirr+(4*4)
             long  @ButtMirr+(4*5), @ButtMirr+(4*6), @ButtMirr+(4*7)
MirrCmd  long 0         ' pointer to command of this process
MirrCog  long 0         ' Cog running SerialCommunicationProcess
NmbMirrE long 16        ' Die Anzahl der Eintrge in den Spiegel

MirrAdrs long  8<<2+TN,  9<<2+TN,  10<<2+TN,  11<<2+TN,  12<<2+TN, 13<<2+TN, 14<<2+TN, 15<<2+TN    ' 
         long 0,0,0,0,0,0,0,0,0,0
LclNodId long LocalNode

ButtMirr long   0, 0, 0, 0,  0, 0, 0, 0
' Shutter control

TimePres    long 0 ' 1/5 sek fr Dauererkennung
TimeFull    long 0 ' 10 Sekunden fr ganze Fahrt
TimePart    long 0 '  3 Sekunden fr etwas Fahrt
TimeRela    long 0 '  3 Sekunden fr etwas Fahrt

Timer       long 0 ' Timer Value

ActState    long 0

CON
  PinA = 26
  PinB = 27



PUB Main   | VersCOG, Stat, PressFlg, oldState, AnyClick, Warner, i

  Warner := ClkFreq/3
  dira [23..16] ~~

  ' Start the touch button detector first
  DecayTim := CLKFREQ / 100
  ToBuRegi := $FF                           ' Have pin 0 to 7 as input
  ToBuCmd  := NmbToBuPar                    ' Number of parameters passed to the process
  VersCOG  := ToBu.start(@PrCBToBu, @@0) -1 ' start Touch button detector
  if VersCOG~>4 <> ToBuVers      ' check for correct version
    Warner := ClkFreq/20

  ' Start the button process
  ButtCmd  := NmbButtPar     ' Number of parameters passed to the process
  VersCOG  := Butt.start(@PrCBButt, @@0) -1 ' start Button & quadrature input; i: 16*Version + ID-Cog
  if VersCOG~>4 <> ButtVers      ' check for correct version
    Warner := ClkFreq/20

  ' Initialize the serial communication process                                          
  rxBiTics := clkfreq / defbdrat                                                        
  txBiTics := clkfreq / defbdrat                                                        
  SeCoMode := defmode                                                                   

  SeCoCmd  := NmbSeCoPar                      ' Setup and start "Serial Communication" Process
  VersCOG  := SeCo.start(@PrCBSeCo, @@0) -1   ' start!
  if VersCOG~>4 <> SecoVers      ' check for correct version
    Warner := ClkFreq/20
  ActState := CmdInvoc  (@SeCoCmd, Run, 1)    ' Wait until system returns "ack" (SeCoCmd -> 0)

  waitcnt (Cnt + onems + ClkFreq*(2-LocalNode))              ' If Local Node==1 (Master) wait 1 ms, if LocalNode==2 (slave) don't wait -> Slave ready when Master seeds token
  

  MirrCmd  := NmbMirrPar                      ' Setup and start "Mirror" Process
  VersCOG  := Mirr.start(@PrCBMirr, @@0) -1   ' start!
  if VersCOG~>4 <> MirrVers      ' check for correct version
    Warner := ClkFreq/20
  ActState := CmdInvoc  (@MirrCmd, Run, 1)     ' Wait until system returns "ack" (SeCoCmd -> 0)
  'clear pending flags
  
  repeat i from 0 to MaxButt-1
    ButtClck[i] := 0
    ButtDClk[i] := 0

  repeat
    !outa[23]

    'LED0: Just mirror state
    outa[0+LEDBase] := ButtMirr[0]    ' just forward button state to LED
    

{

    outa[1+16] := ButtMirr[1]
    if ButtMirr[3] > 0
      outa[3+16]~~
    else  
      outa[3+16]~
    if  ButtMirr[2]
      ButtMirr[2] := 0
      !outa[2+16]
    if  ButtMirr[5]
      ButtMirr[5] := 0
'      repeat i from 0 to MaxButt-1 ' no need to to this, as values are not mirrored
'        ButtClck[i] := 0
'        ButtDClk[i] := 0

}

  
  TimePres    := 450         ' 1 ms sek fr Dauererkennung
  TimeFull    := ClkFreq* 3'10  ' 10 Sekunden fr ganze Fahrt
  TimePart    := ClkFreq* 1'3  '  3 Sekunden fr etwas Fahrt
  TimeRela    := ClkFreq/3  ' 1/10 sek Entspannung


  


PRI CmdInvoc (CmdPtr, Cmd, Stat) ' Wait until process idle, output cmd, wait for acknowledge, return "Stat" for documentation/debuging purposes
    repeat while long[CmdPtr]
    long[CmdPtr] := Cmd  
    repeat while long[CmdPtr]
    Result := Stat

DAT